package it.unitn.disi.ronchet.esame22_06_27.controllers;

import it.unitn.disi.ronchet.esame22_06_27.functionalities.Setup;
import it.unitn.disi.ronchet.esame22_06_27.models.UserProperties;
import it.unitn.disi.ronchet.esame22_06_27.models.AdminPageBean;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;
import java.io.IOException;
import java.util.HashMap;

@WebServlet(name = "AdminPageServlet", value = "/adminPageServlet")
public class AdminPageServlet extends HttpServlet {
    ServletContext ctx=null;
    @Override
    public void init(){
        ctx=this.getServletContext();
        //make sure data structure is in place
        if (ctx.getAttribute("userList")==null) new Setup(ctx);
    }

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        System.out.println("===> Entering AdminPageServlet doGet");
        doPost(request,response);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        System.out.println("===> Entering AdminPageServlet doPost");
        //check authorization as admin
        HttpSession session= request.getSession(false);
        if (session==null || ! "admin".equals(session.getAttribute("username"))) {
            request.getRequestDispatcher("adminErrorPage.html").forward(request, response);
            return;
        }
        // prepare data for admin page
        System.out.println("access as admin");
        HashMap<String, UserProperties>userList=(HashMap<String,UserProperties>)ctx.getAttribute("userList");
        //long timestamp=(Long)ctx.getAttribute("lastUpdate");
        AdminPageBean bean=new AdminPageBean(userList);
        request.setAttribute("adminBean",bean);
        request.getRequestDispatcher("WEB-INF/adminPage.jsp").forward(request, response);
    }
}
