package it.unitn.disi.ronchet.esame22_06_27.controllers;

import it.unitn.disi.ronchet.esame22_06_27.functionalities.Setup;
import it.unitn.disi.ronchet.esame22_06_27.models.UserProperties;
import it.unitn.disi.ronchet.esame22_06_27.models.UserPageBean;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;
import java.io.IOException;
import java.util.HashMap;

@WebServlet(name = "UserPageServlet", value = "/userPageServlet")
public class UserPageServlet extends HttpServlet {
    ServletContext ctx=null;
    HashMap<String, UserProperties> userList=null;
    public void init(){
        ctx=this.getServletContext();
        //make sure data structure is in place
        if (ctx.getAttribute("userList")==null) new Setup(ctx);
        userList=(HashMap<String,UserProperties>)ctx.getAttribute("userList");
    }

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        System.out.println("===> Entering UserPageServlet doGet");
        doPost(request,response);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        System.out.println("===> Entering UserPageServlet doPost");
        // retrieve data
        HttpSession session=request.getSession();
        String username=(String)session.getAttribute("username");
        if (session==null || "admin".equals(session.getAttribute("username"))) {
            request.getRequestDispatcher("frontController").forward(request, response);
            return;
        }
        System.out.println("USERPAGESERVLET - username : "+username);
        UserProperties up=userList.get(username);
        String style=up.getCss();
        System.out.println("USERPAGESERVLET - css : "+style);
        boolean isActive=up.getConnected();
        //long timestamp=(Long)ctx.getAttribute("lastUpdate");
        //System.out.println("USERPAGESERVLET - lastupdate : "+timestamp);
        UserPageBean upb=new UserPageBean(username, style, isActive);
        request.setAttribute("theBean",upb);
        RequestDispatcher rd=request.getRequestDispatcher("WEB-INF/userPage.jsp");
        rd.forward(request,response);
    }
}
