package it.unitn.disi.ronchet.esame22_06_27.functionalities;

import it.unitn.disi.ronchet.esame22_06_27.models.UserProperties;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;
import java.io.IOException;
import java.util.HashMap;

@WebServlet(name = "AJAXServlet", value = "/ajaxServlet")
public class AJAXServlet extends HttpServlet {
    ServletContext ctx=null;
    HashMap<String, UserProperties> userList;
    @Override
    public void init(){
        ctx=this.getServletContext();
        //make sure data structure is in place
        if (ctx.getAttribute("userList")==null) new Setup(ctx);
        userList=(HashMap<String, UserProperties>)ctx.getAttribute("userList");
    }@Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        request.getRequestDispatcher("frontController");
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        System.out.println("received POST request");
        String name = request.getParameter("name");
        String css = request.getParameter("css");
        System.out.println(name+" : "+css);
        String output="no action";
        if (css == null) {
             output = listUsers(name);
        } else {
             output = changeCSS(name, css);
        }
        response.setContentType("text/html");
        response.getOutputStream().print(output);
        System.out.println(output);
    }

    private String listUsers(String name) {
        UserProperties up=userList.get(name);
        StringBuilder sb=new StringBuilder("<p><b>User :");
        sb.append(name);
        sb.append("</b> - CSS: ");
        sb.append(up.getCss());
        sb.append(" - is connected ? ");
        sb.append(up.getConnected());
        sb.append("</p>");
        return sb.toString();
    }
    private String changeCSS(String name, String css) {
        System.out.println(name+" "+css);
        UserProperties up=userList.get(name);
        // sincronizziamo solo le scritture
        synchronized (ctx) {
            up.setCss(css);
            userList.put(name, up);
        }
        return "last operation executed: applied "+css+" to user "+name;
    }
}
